% qcamacros.sty
% author Max Kahnt (max.kahnt+qcamacros@googlemail.com)

\def\filedate{2015/08/05}
\def\fileversion{0.1.6}

% TODO this is arbitrary
\NeedsTeXFormat{LaTeX2e}[1994/06/01] 

\ProvidesPackage{qcamacros}[\filedate\space v\fileversion]

\RequirePackage{lineno}
\RequirePackage{cleveref}
\RequirePackage{xparse}
\RequirePackage{environ}
\RequirePackage{etoolbox}

\newenvironment{mynumbering}{\resetlinenumber[1]\begin{linenumbers}}{\end{linenumbers}}

\newcounter{myCategoryItemCounter}
\newcommand{\myref}[1]{\cref{#1cref}, Zeile \ref{#1begin}-\ref{#1end}}
\newcommand{\nodo}{\let\do\relax\newcommand*{\do}{}}


% declare list
\listgadd{\mycitelist}{dummy}

\newcommand{\newcite}[3]
{%
  \listgadd{\mycitelist}{#1}%
  \forcsvlist{\listcsgadd{#1citeCategories}}{#2}%
  \expandafter\gdef\csname #1content\endcsname{#3}%
  \expandafter\gdef\csname #1categories\endcsname{#2}%
}


\NewEnviron{mycite}[2]
{%
  \label{#1cref}%
  \linelabel{#1begin}%
  \immediate\write\@auxout{\noexpand\newcite{#1}{\detokenize{#2}}{\expandonce\BODY}}
  \BODY%
  #2
  \linelabel{#1end}%
}

\newcommand{\printCite}[1]{\textit{``\csname #1content\endcsname''}}
\newcommand{\infoCite}[1]{-- This cite is found in \myref{#1} and is in the following categories: \emph{\csname #1categories\endcsname}.}
\newcommand{\printCiteWithInfo}[1]{\printCite{#1} \infoCite{#1}}


\newcommand{\printbodyifhascategory}[3]
{
  \ifinlistcs{#2}{#1citeCategories}{#3\printCite{#1}}{}
}

\newcommand{\printbodyifhascategorywithinfo}[3]
{
  \ifinlistcs{#2}{#1citeCategories}{#3\printCite{#1} \infoCite{#1}}{}
}

\newcommand{\numCategoryCites}[1]
{%
\nodo%
\setcounter{myCategoryItemCounter}{0}%
\renewcommand*{\do}[1]{%
\ifinlistcs{#1}{##1citeCategories}{\stepcounter{myCategoryItemCounter}}{}%
}%
\dolistloop{\mycitelist}%
\number\value{myCategoryItemCounter}%
}

\newcommand{\printAllCategory}[1]
{
  All cites that are in category \emph{#1}: % 
  \begin{enumerate}
    \nodo
   \renewcommand*{\do}[1]{\printbodyifhascategory{##1}{#1}{\item}}
   \dolistloop{\mycitelist} 
   \item End of list (if this is the only item in the list but you expect more, maybe compile again).
 \end{enumerate}
  
}

\newcommand{\printAllCategoryWithInfo}[1]
{
  All cites that are in category \emph{#1}:  
  \begin{enumerate}
    \nodo
    \renewcommand*{\do}[1]{\printbodyifhascategorywithinfo{##1}{#1}{\item}}
    \dolistloop{\mycitelist} 
   \item End of list (if this is the only item in the list but you expect more, maybe compile again).
  \end{enumerate}
}

\newcommand{\countAllCategory}[1]
{%
Category \emph{#1} contains \numCategoryCites{#1} cites.
}

\endinput

VERSION HISTORY:

v0.1.6 2015/08/05  Name change from refintX to qcamacros.

v0.1.5 2015/08/05  Adding documentation, proper package creation.  

v0.1.4 2015/08/05  Support umlauts ins category names.

v0.1.3 2015/08/05  Fix error with \do command not defined.
